import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class Journal extends MIDlet implements CommandListener {
 private static Display display;
 private recordStores rsMain,rsNames,rsCategories,rsBalls;
 public static final int STR_LENGTH=16; //   
 public int names=0, categories=0, balls=0, selectedBalls=0; //  
 private errorForm er;
 public static final int 
  MODE_MENU=0,
  MODE_NAMES=1,
  MODE_CATEGORIES=2,
  MODE_BALLS1=3,
  MODE_BALLS2=4,
  MODE_BALLS=5;
 private int mode=MODE_MENU;
 private int selector=0; //  
 private boolean eventReplace=false;
 public String 
  namesStr="",
  categoriesStr="",
  ballsStr="";
 private String [] mainMenuStr =  { 
  namesStr, //0
  categoriesStr, //1
  ballsStr, //2
  "", //3, optionsForm
  " " //4
 };
 public String 
  allStr="",
  errorHdr="";
 private String selectedName, selectedCategory, selectedString;
 private int selectedNumber=0;
 private Command 
  cmdExit = new Command ("", Command.EXIT, 0),
  cmdMenu = new Command ("", Command.BACK, 0),
  cmdBalls = new Command ("", Command.ITEM, 1),
  cmdReport = new Command ("", Command.ITEM, 1),
  cmdAdd = new Command ("", Command.ITEM, 1),
  cmdChange = new Command ("", Command.ITEM, 1),
  cmdDelete = new Command ("", Command.ITEM, 1),
  cmdDeleteAll = new Command (" ", Command.ITEM, 1),
  cmdSelect = new Command ("", Command.ITEM, 1),
  cmdShow = new Command ("", Command.ITEM, 1);
 
 public List mainMenu = new List("...", Choice.IMPLICIT, mainMenuStr, null);
 public List namesList = new List(namesStr, Choice.IMPLICIT);
 public List categoriesList = new List(categoriesStr, Choice.IMPLICIT);
 public List ballsList = new List(ballsStr, Choice.IMPLICIT);
 public List selectedList = new List(ballsStr, Choice.IMPLICIT);
 private optionsForm optionsForm;
 private alertForm alertForm;
 private reportForm reportForm;
 private showForm showForm;
 private Form 
  inputForm = new Form (""),
  inputForm2 = new Form ("");
 private Command 
  cmdBack=new Command ("", Command.BACK, 0),
  cmdGo=new Command ("", Command.ITEM, 1);
 private TextField 
  input1=new TextField (":","",STR_LENGTH,TextField.ANY),
  input2=new TextField (":","",6,TextField.NUMERIC);
 public String name0, category0;
 public int ball0;

 public Journal () {
  mainMenu.setCommandListener(this);
 }

 public void startApp() {
  display = Display.getDisplay(this);
  display.setCurrent(mainMenu);

  String s; 
  rsMain=new recordStores (display,"z_main",STR_LENGTH*2);
  s=rsMain.getRecord (1);
  if (s!=null) names=Integer.parseInt (s);
  s=rsMain.getRecord (2);
  if (s!=null) categories=Integer.parseInt (s);
  s=rsMain.getRecord (3);
  if (s!=null) balls=Integer.parseInt (s);
  s=rsMain.getRecord (4);
  if (s!=null) {
   namesStr=s.substring(0).trim();
   mainMenu.set (0, namesStr, null);
   namesList.setTitle (namesStr);
  }
  s=rsMain.getRecord (5);
  if (s!=null) {
   categoriesStr=s.substring(0).trim();
   mainMenu.set (1, categoriesStr, null);
   categoriesList.setTitle (categoriesStr);
  }
  s=rsMain.getRecord (6);
  if (s!=null) {
   ballsStr=s.substring(0).trim();
   mainMenu.set (2, ballsStr, null);
   selectedList.setTitle (ballsStr);
  }

  rsNames=new recordStores (display,"z_names",STR_LENGTH*2);
  int n=0;
  if (rsNames!=null) for (int i=0; i<names; i++) {
   s=rsNames.getRecord (i+1);
   if (s!=null) { n++; namesList.append (s, null); }
  }
  names=n; // namesList.size(),    - NullPointerException

  rsCategories=new recordStores (display,"z_categories",STR_LENGTH*2);
  n=0;
  if (rsCategories!=null) for (int i=0; i<categories; i++) {
   s=rsCategories.getRecord (i+1);
   if (s!=null) { n++; categoriesList.append (s, null); }
  }
  categories=n;

  rsBalls=new recordStores (display,"z_balls",STR_LENGTH*6);
  n=0;
  if (rsBalls!=null) for (int i=0; i<balls; i++) {
   s=rsBalls.getRecord (i+1);
   if (s!=null) { n++; ballsList.append (s, null); }
  }
  balls=n;
  mainMenu.addCommand (cmdExit);
  namesList.addCommand(cmdMenu); namesList.addCommand(cmdBalls); namesList.addCommand(cmdReport); namesList.addCommand(cmdAdd); namesList.addCommand(cmdChange); namesList.addCommand(cmdDelete); namesList.addCommand(cmdDeleteAll); namesList.setCommandListener (this);
  categoriesList.addCommand(cmdMenu); categoriesList.addCommand(cmdBalls); categoriesList.addCommand(cmdReport);  categoriesList.addCommand(cmdAdd); categoriesList.addCommand(cmdChange); categoriesList.addCommand(cmdDelete); categoriesList.addCommand(cmdDeleteAll); categoriesList.setCommandListener (this);  
  selectedList.addCommand(cmdMenu); selectedList.addCommand(cmdShow); selectedList.addCommand(cmdChange); selectedList.addCommand(cmdDelete); selectedList.setCommandListener (this);
  inputForm.append (input1); inputForm.addCommand(cmdBack); inputForm.addCommand(cmdGo); inputForm.setCommandListener(this);
  inputForm2.append (input2); inputForm2.addCommand(cmdBack); inputForm2.addCommand(cmdGo); inputForm2.setCommandListener(this);

  if ((names>0) && (categories>0)) mainMenu.setSelectedIndex (2,true);
  mainMenu.setTitle (" ");
 }

 public void pauseApp () {}

 public void destroyApp (boolean unconditional) throws MIDletStateChangeException {
  rsMain.setRecord (1,""+names);
  rsMain.setRecord (2,""+categories);
  rsMain.setRecord (3,""+balls);
  rsMain.setRecord (4,namesStr);
  rsMain.setRecord (5,categoriesStr);
  rsMain.setRecord (6,ballsStr);
  rsMain.closeRecords();
  for (int i=0; i<names; i++) rsNames.setRecord (i+1,namesList.getString (i));
  rsNames.closeRecords();
  for (int i=0; i<categories; i++) rsCategories.setRecord (i+1,categoriesList.getString (i));
  rsCategories.closeRecords();
  for (int i=0; i<balls; i++) rsBalls.setRecord (i+1,ballsList.getString (i));
  rsBalls.closeRecords();
  notifyDestroyed ();
 }

 public boolean check (List lst, String s) {
  for (int i=0; i<lst.size(); i++) {
   if (lst.getString(i).trim().compareTo(s.trim())==0) return true;
  }
  return false;
 }

 private void restoreNamesList () {
  namesList.removeCommand (cmdSelect);
  namesList.addCommand (cmdBalls); namesList.addCommand (cmdReport); namesList.addCommand (cmdAdd); namesList.addCommand (cmdChange); namesList.addCommand (cmdDelete); namesList.addCommand (cmdDeleteAll);
  if (namesList.size()>0) {
   if (namesList.getString(0).compareTo(allStr)==0) namesList.delete (0);
  }
 }

 private void restoreCategoriesList () {
  categoriesList.removeCommand (cmdSelect);
  categoriesList.addCommand (cmdBalls); categoriesList.addCommand (cmdReport); categoriesList.addCommand (cmdAdd); categoriesList.addCommand (cmdChange); categoriesList.addCommand (cmdDelete); categoriesList.addCommand (cmdDeleteAll);
  if (categoriesList.size()>0) {
   if (categoriesList.getString(0).compareTo(allStr)==0) categoriesList.delete (0);
  }
 }

 private int changeList (List nList, int n, String nStr, int mode) {
  String eventStr,name1;
  int eventNum,i;
  er = new errorForm (display,errorHdr);
  name1=input1.getString().trim();
  if (name1.compareTo("")==0) {
   er.show ("     !");
  }
  else if (name1.compareTo(allStr)==0) {
   er.show (",     "+allStr);
  }
  else {
   if (check(nList,name1)==true) {
    er.show (name1+"     "+nStr);
   }
   else {
    eventNum=nList.getSelectedIndex();
    if (eventReplace==true) changeBalls (mode,nList.getString(eventNum),name1);
    if (n==0) { n=1; i=0; nList.append (name1, null); }
    else {
     i=0;
     while (i<n) {
      eventStr=nList.getString(i).trim();
      if (name1.compareTo(eventStr)<=0) break;
      i++;
     }
     if (eventReplace==false) {
      if (i<n) nList.insert (i,name1,null);
      else nList.append (name1, null);
     }
     else {
      if (i==eventNum) nList.set (i,name1,null);
      else {
       nList.delete (eventNum);
       if (i==n) nList.append (name1, null); 
       else {
        if (i>eventNum) i--;
        nList.insert (i,name1,null);
       }
      }
     }
     if (eventReplace==false) n++;
    }
    if (i<0) i=0;
    else if (i>nList.size()-1) i=nList.size()-1;
    nList.setSelectedIndex (i, true);
    display.setCurrent(nList);
   }
  }
  return n;
 }

 public void get0 (String s) {
  int n,n2;
  n=s.lastIndexOf (',');
  name0=s.substring(0,n);
  n2=s.lastIndexOf (':');
  category0=s.substring(n+2,n2);
  ball0=Integer.parseInt(s.substring(n2+2));
 }

 public int getSelectedList () {
  int i,n,n2;
  String s;
  balls=ballsList.size();
  if (balls<1) return 0;
  do { i=selectedList.size(); if (i>0) selectedList.delete (0); } while (i>0);
  for (i=0; i<balls; i++) {
   s=ballsList.getString(i);
   get0 (s);
   if (selectedName.compareTo(allStr)==0) {
    if (selectedCategory.compareTo(allStr)==0) selectedList.append (s, null);
    else if (selectedCategory.compareTo(category0)==0) selectedList.append (s, null);
   }
   else if (selectedName.compareTo(name0)==0) {
    if (selectedCategory.compareTo(allStr)==0) selectedList.append (s, null);
    else if (selectedCategory.compareTo(category0)==0) selectedList.append (s, null);
   }
  }
  return selectedList.size();
 }

 private void deleteBalls (String s, int mode) {
  int i=0;
  while (i<ballsList.size()) {
   get0 (ballsList.getString(i));
   if ( (mode==MODE_NAMES) && (name0.compareTo(s)==0) ||
        (mode==MODE_CATEGORIES) && (category0.compareTo(s)==0)) ballsList.delete (i);
   else if ((mode==MODE_BALLS) && (ballsList.getString(i).compareTo(s)==0)) {
    ballsList.delete (i); break;
   }
   else i++;
  }
  balls=ballsList.size();
 }

 public void deleteAll () {
  int i=0;
  String s;
  if ((mode==MODE_NAMES) && (names>0)) {
   do { 
    i=namesList.size(); 
    if (i>0) {
     s=namesList.getString (0);
     deleteBalls (s,MODE_NAMES);
     namesList.delete (0); 
    }
   } while (i>0);
   names=0;
  }
  else if ((mode==MODE_CATEGORIES) && (categories>0)) {
   do { 
    i=categoriesList.size(); 
    if (i>0) {
     s=categoriesList.getString (0);
     deleteBalls (s,MODE_CATEGORIES);
     categoriesList.delete (0); 
    }
   } while (i>0);
   categories=0;
  }
  mode=MODE_MENU; 
  display.setCurrent (mainMenu);
 }

 private void changeBalls (int mode,String from, String to) {
  for (int i=0; i<ballsList.size(); i++) {
   get0 (ballsList.getString(i));
   if ((mode==MODE_NAMES) && (name0.compareTo(from)==0))
    ballsList.set (i,to+", "+category0+": "+ball0,null);
   else if ((mode==MODE_CATEGORIES) && (category0.compareTo(from)==0)) 
    ballsList.set (i,name0+", "+to+": "+ball0,null);
   else if ((mode==MODE_BALLS) && (ballsList.getString(i).compareTo(from)==0))
    ballsList.set (i,to,null);
  }
 }

 private void toBalls2 () {
  selectedName=namesList.getString(namesList.getSelectedIndex());
  restoreNamesList ();
  mode=MODE_BALLS2;
  categoriesList.removeCommand (cmdBalls); categoriesList.removeCommand (cmdReport); categoriesList.removeCommand (cmdAdd); categoriesList.removeCommand (cmdChange); categoriesList.removeCommand (cmdDelete); categoriesList.removeCommand (cmdDeleteAll);
  categoriesList.addCommand (cmdSelect);
  if (categories>0) { 
   int n=categoriesList.getSelectedIndex ();
   categoriesList.insert (0, allStr, null);
   categoriesList.setSelectedIndex (n+1, true);
  }
  else categoriesList.append (allStr, null);
  display.setCurrent (categoriesList);
 }

 private  void toSelected () {
  selectedCategory=categoriesList.getString(categoriesList.getSelectedIndex());
  restoreCategoriesList ();
  selectedBalls=getSelectedList ();
  if (selectedBalls>0) {
   mode=MODE_BALLS;
   display.setCurrent (selectedList);
  }
  else if ( (selectedName.compareTo(allStr)!=0) && (selectedCategory.compareTo(allStr)!=0)) {
   eventReplace=false;
   input2.setString ("");
   inputForm2.setTitle ("  "+ballsStr+"  "+namesStr+"="+selectedName+"  "+categoriesStr+"="+selectedCategory);
   mode=MODE_BALLS;
   display.setCurrent (inputForm2);
  }
  else {
   mode=MODE_MENU;
   display.setCurrent (new Alert (errorHdr,"     "+namesStr+"="+selectedName+"  "+categoriesStr+"="+selectedCategory,null,AlertType.ERROR),mainMenu);
  }
 }

 private void showBalls () {
  String st=selectedList.getString(selectedList.getSelectedIndex());
  showForm = new showForm (this, selectedName+", "+selectedCategory, st);
  display.setCurrent (showForm);
 }

 private void selectNames () {
  if (names>0) {
   selectedName=namesList.getString(namesList.getSelectedIndex());
   selectedCategory=allStr;
   selectedBalls=getSelectedList ();
   if (selectedBalls>0) {
    mode=MODE_BALLS;
    display.setCurrent (selectedList);
   }
   else {
    mode=MODE_NAMES;
    display.setCurrent (new Alert (errorHdr,"     "+namesStr+"="+selectedName+"  "+categoriesStr+"="+selectedCategory,null,AlertType.ERROR),namesList);
   }    
  }
  else {
   er = new errorForm (display, errorHdr);
   er.show ("    ");
  }
 }

 private void selectCategories () {
  if (categories>0) {
   selectedName=allStr;
   selectedCategory=categoriesList.getString(categoriesList.getSelectedIndex());
   selectedBalls=getSelectedList ();
   if (selectedBalls>0) {
    mode=MODE_BALLS;
    display.setCurrent (selectedList);
   }
   else {
    mode=MODE_CATEGORIES;
    display.setCurrent (new Alert (errorHdr,"     "+namesStr+"="+selectedName+"  "+categoriesStr+"="+selectedCategory,null,AlertType.ERROR),categoriesList);
   }
  }
  else {
   er = new errorForm (display, errorHdr);
   er.show ("    ");
  }
 }

 public void commandAction(Command c, Displayable d)  {
  if (c==cmdExit) {
   try {
    destroyApp (false);
   }
   catch (MIDletStateChangeException msce) {
    mainMenu.setTitle ("...");
    display.setCurrent (mainMenu);
   }
  }
  else if (c == cmdMenu) { //   
   if (mode==MODE_BALLS1) restoreNamesList ();
   else if (mode==MODE_BALLS2) restoreCategoriesList ();
   mode=MODE_MENU;
   display.setCurrent(mainMenu);
  }
  else if (c==cmdSelect) { //     ->    
   if (mode==MODE_BALLS1) toBalls2 ();
   else if (mode==MODE_BALLS2) toSelected ();
  }
  else if (c==cmdGo) { // 
   if (mode==MODE_NAMES) {
    names=changeList (namesList,names,namesStr,MODE_NAMES);
   }
   else if (mode==MODE_CATEGORIES) {
    categories=changeList (categoriesList,categories,categoriesStr,MODE_CATEGORIES);
   }
   else if (mode==MODE_BALLS) {
    String s=input2.getString().trim();
    if (eventReplace==true) {
     changeBalls (MODE_BALLS,selectedString,selectedName+", "+selectedCategory+": "+s);
     selectedList.set (selectedNumber, selectedName+", "+selectedCategory+": "+s, null);
    }
    else {
     ballsList.append (selectedName+", "+selectedCategory+": "+s, null);
     balls=ballsList.size();
     selectedList.append (selectedName+", "+selectedCategory+": "+s, null);
     selectedBalls++;
    }
    display.setCurrent (selectedList);
   }
  }
  else if (c==cmdBack) { //     
   if (mode==MODE_NAMES) display.setCurrent (namesList);
   else if (mode==MODE_CATEGORIES) display.setCurrent (categoriesList);
   else if (mode==MODE_BALLS) {
    if (selectedBalls>0) display.setCurrent (selectedList);
    else {
     mode=MODE_MENU;
     display.setCurrent (mainMenu);   
    }
   }
  }
  else if (c==cmdBalls) { //   
   if (mode==MODE_NAMES) selectNames ();
   else if (mode==MODE_CATEGORIES) selectCategories ();
  }
  else if (c==cmdReport) { //     /
   if ((mode==MODE_NAMES) && (names>0)) {
    selectedName=namesList.getString(namesList.getSelectedIndex());
    selectedCategory=allStr;
    selectedBalls=getSelectedList ();
    if (selectedBalls>0) {
     reportForm = new reportForm (this, "  "+namesStr+"="+selectedName,MODE_NAMES);
     display.setCurrent (reportForm);
    }
    else {
     mode=MODE_NAMES;
     display.setCurrent (new Alert (errorHdr,"     "+namesStr+"="+selectedName+"  "+categoriesStr+"="+selectedCategory,null,AlertType.ERROR),namesList);
    }    
   }
   else if ((mode==MODE_CATEGORIES) && (categories>0)) {
    selectedName=allStr;
    selectedCategory=categoriesList.getString(categoriesList.getSelectedIndex());
    selectedBalls=getSelectedList ();
    if (selectedBalls>0) {
     reportForm = new reportForm (this, "  "+categoriesStr+"="+selectedCategory, MODE_CATEGORIES);
     display.setCurrent (reportForm);
    }
    else {
     mode=MODE_CATEGORIES;
     display.setCurrent (new Alert (errorHdr,"     "+namesStr+"="+selectedName+"  "+categoriesStr+"="+selectedCategory,null,AlertType.ERROR),categoriesList);
    }
   }
   else {
    er = new errorForm (display, errorHdr);
    er.show ("   ");
   }
  }
  else if (c==cmdChange) { //  
   eventReplace=true;
   int n;
   String s="";
   if ((mode==MODE_NAMES) && (names>0)) {
    inputForm.setTitle ("  "+namesStr);
    n=namesList.getSelectedIndex();
    s=namesList.getString (n);
    input1.setString (s);
    display.setCurrent (inputForm);
   }
   else if ((mode==MODE_CATEGORIES) && (categories>0)) { 
    inputForm.setTitle ("  "+categoriesStr);
    n=categoriesList.getSelectedIndex();
    s=categoriesList.getString (n);
    input1.setString (s);
    display.setCurrent (inputForm);
   }
   else if ((mode==MODE_BALLS) && (selectedBalls>0)) { 
    n=selectedList.getSelectedIndex();
    s=selectedList.getString (n);
    get0 (s);
    inputForm2.setTitle (" "+ballsStr+"  "+namesStr+"="+name0+"  "+categoriesStr+"="+category0);
    selectedString=s;
    selectedName=name0;
    selectedCategory=category0;
    selectedNumber=n;
    s=""+ball0;
    input2.setString (s);
    display.setCurrent (inputForm2);
   }
  }
  else if (c==cmdAdd) { // 
   eventReplace=false;
   boolean go=false;
   if (mode==MODE_NAMES) { go=true; inputForm.setTitle ("  "+namesStr); }
   else if (mode==MODE_CATEGORIES) { go=true; inputForm.setTitle ("  "+categoriesStr); }
   input1.setString ("");
   if (go==true) display.setCurrent (inputForm);
  }
  else if (c==cmdShow) showBalls (); //   SelectedList
  else if (c==cmdDelete) { // 
   int eventNum;
   if ((mode==MODE_NAMES) && (names>0)) {
    eventNum = namesList.getSelectedIndex();
    deleteBalls (namesList.getString(eventNum),MODE_NAMES);
    namesList.delete (eventNum);
    names--;
    if (names==0) {
     mode = MODE_MENU;
     display.setCurrent(mainMenu);
    }
    else display.setCurrent(namesList);
   }
   else if ((mode==MODE_CATEGORIES) && (categories>0)) { 
    eventNum = categoriesList.getSelectedIndex();
    deleteBalls (categoriesList.getString(eventNum),MODE_CATEGORIES);
    categoriesList.delete (eventNum);
    categories--;
    if (categories==0) {
     mode = MODE_MENU;
     display.setCurrent(mainMenu);
    }
    else display.setCurrent(categoriesList);
   }
   else if ((mode==MODE_BALLS) && (selectedBalls>0)) { 
    eventNum = selectedList.getSelectedIndex();    
    deleteBalls (selectedList.getString(eventNum),MODE_BALLS);
    selectedList.delete (eventNum);
    selectedBalls--;
    if (selectedBalls==0) {
     mode = MODE_MENU;
     display.setCurrent(mainMenu);
    }
    else display.setCurrent(selectedList);
   }
  }
  else if (c==cmdDeleteAll) {
   alertForm = new alertForm (this,"!");
   alertForm.show ("     ?");
  }
  else if (c==List.SELECT_COMMAND) {
   if (mode==MODE_MENU) {
    selector = mainMenu.getSelectedIndex();
    switch (selector) {
     case 0:
      mode=MODE_NAMES;
      display.setCurrent (namesList);
     break;
     case 1:
      mode=MODE_CATEGORIES;
      display.setCurrent (categoriesList);
     break;
     case 2:
      mode=MODE_BALLS1;
      namesList.removeCommand (cmdBalls); namesList.removeCommand (cmdReport); namesList.removeCommand (cmdAdd); namesList.removeCommand (cmdChange); namesList.removeCommand (cmdDelete); namesList.removeCommand (cmdDeleteAll);
      namesList.addCommand (cmdSelect);
      if (names>0) {
       int n=namesList.getSelectedIndex ();
       namesList.insert (0, allStr, null);
       namesList.setSelectedIndex (n+1, true);
      }
      else namesList.append (allStr, null);
      display.setCurrent (namesList);
     break;
     case 3:
      optionsForm = new optionsForm (this, mainMenuStr[3]);
      display.setCurrent (optionsForm);
     break;
     case 4:
      er = new errorForm (display," ");
      er.show (
       " \" \"        . ,     ,  -     ,   -  ,      ,  -   ,  -     ,     :-)\n"+
       " -     .          ,        .\n"+
       " -    ,     .        .\n"+
       " -    ( ),   (  ),   (  -  ) .       .\n"+
       " -      - ,   ,      .\n"+
       "     - ,     .\n"+
       "() PerS, pers@mail.ru, 2005");
     break;
    }
   }
   else if (mode==MODE_NAMES) selectNames ();
   else if (mode==MODE_CATEGORIES) selectCategories ();
   else if (mode==MODE_BALLS1) toBalls2 ();
   else if (mode==MODE_BALLS2) toSelected ();
   else if (mode==MODE_BALLS) showBalls ();
  }
 }

}